#ifndef SQUARE_HPP
#define SQUARE_HPP

#include <array>
#include <iostream>
#include <vector>

#include "global.hpp"
#include "util.hpp"

// TODO: Consider replacing this with a set of int packed diagonals.
typedef std::array<std::array<unsigned int, N>, N> Square;

std::ostream& operator << (std::ostream& stream, const Square& square);
std::ostream& operator << (std::ostream& stream, const std::vector<Square>& square);

std::vector<Square> parseSquares(std::istream& stream);

void swapSquares(std::vector<Square>& squares, unsigned int i, unsigned int j);

#endif // SQUARE_HPP
